<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.15" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__wiced__mem" kind="group">
    <compoundname>wiced_mem</compoundname>
    <title>Memory Management</title>
    <innerclass prot="public" refid="structwiced__bt__pool__statistics__t">wiced_bt_pool_statistics_t</innerclass>
    <innerclass prot="public" refid="structwiced__bt__heap__statistics__t">wiced_bt_heap_statistics_t</innerclass>
    <innerclass prot="public" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</innerclass>
      <sectiondef kind="typedef">
      <memberdef id="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba" kind="typedef" prot="public" static="no">
        <type>void</type>
        <definition>typedef void wiced_bt_buffer_t</definition>
        <argsstring />
        <name>wiced_bt_buffer_t</name>
        <briefdescription>
<para>WICED BT Buffer. </para>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="26" column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="26" />
      </memberdef>
      <memberdef id="group__wiced__mem_1ga8eb99f9920449033af7323ed0eb8f69c" kind="typedef" prot="public" static="no">
        <type>struct t_wiced_bt_pool</type>
        <definition>typedef struct t_wiced_bt_pool wiced_bt_pool_t</definition>
        <argsstring />
        <name>wiced_bt_pool_t</name>
        <briefdescription>
<para>WICED BT Pool. </para>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="30" column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="26" />
      </memberdef>
      <memberdef id="group__wiced__mem_1ga29951f8f099d15eb96c47cfbdf656c3c" kind="typedef" prot="public" static="no">
        <type>struct t_wiced_bt_heap</type>
        <definition>typedef struct t_wiced_bt_heap wiced_bt_heap_t</definition>
        <argsstring />
        <name>wiced_bt_heap_t</name>
        <briefdescription>
<para>WICED BT Heap. </para>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="32" column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="26" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__wiced__mem_1gae7ff550ebc3ec2693de3b360f1a1539f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t wiced_memory_get_free_bytes</definition>
        <argsstring>(void)</argsstring>
        <name>wiced_memory_get_free_bytes</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Returns the number of free bytes of RAM left. </para>
        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>the number of free bytes of RAM left </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="86" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1gabd087700ddd0362c48b52e9c6f66a059" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga29951f8f099d15eb96c47cfbdf656c3c">wiced_bt_heap_t</ref> *</type>
        <definition>wiced_bt_heap_t* wiced_bt_create_heap</definition>
        <argsstring>(const char *name, void *p_area, int size, wiced_bt_lock_t *p_lock, wiced_bool_t b_make_default)</argsstring>
        <name>wiced_bt_create_heap</name>
        <param>
          <type>const char *</type>
          <declname>name</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>p_area</declname>
        </param>
        <param>
          <type>int</type>
          <declname>size</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__lock__t">wiced_bt_lock_t</ref> *</type>
          <declname>p_lock</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__gentypes_1ga2bc92bd117cfd3f6ec4ae452e6ced064">wiced_bool_t</ref></type>
          <declname>b_make_default</declname>
        </param>
        <briefdescription>
<para>Initializes dynamic memory area. </para>
        </briefdescription>
        <detaileddescription>
<para>Application reserves an area for dynamic variable memory allocations with this call. Application can now allocate variable sized buffers as against fixed sized buffer allocations from the pools initialized with calls to wiced_bt_create_pool and allocated using wiced_bt_get_buffer_from_pool.</para>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">name</parametername>
</parameternamelist>
<parameterdescription>
<para>: Friendly name of the heap </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_area</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to area to use for the heap. If NULL, WICED will allocate the area. </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>: Size the area passed in. If no area passed in, this is the size of the heap desired. </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_lock</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointers to lock functions to use during heap manipulation. If NULL, then it is assumed that the application handles disabling of preemption. </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">b_make_default</parametername>
</parameternamelist>
<parameterdescription>
<para>Flag as to whether the heap will be the default heap.</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>wiced_bt_heap_t * - pointer to heap, or NULL if the heap creation failed. </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="104" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga0f37a61eaed4ad2c267d8b70af53bcfb" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_delete_heap</definition>
        <argsstring>(wiced_bt_heap_t *p_heap)</argsstring>
        <name>wiced_bt_delete_heap</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga29951f8f099d15eb96c47cfbdf656c3c">wiced_bt_heap_t</ref> *</type>
          <declname>p_heap</declname>
        </param>
        <briefdescription>
<para>Deletes the heap created with <ref kindref="member" refid="group__wiced__mem_1gabd087700ddd0362c48b52e9c6f66a059">wiced_bt_create_heap</ref>. </para>
        </briefdescription>
        <detaileddescription>
<para>The heap area is freed back to the platform in case the wiced_bt_create_heap was called with p_area set to NULL.</para>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_heap</parametername>
</parameternamelist>
<parameterdescription>
<para>: Heap created with <ref kindref="member" refid="group__wiced__mem_1gabd087700ddd0362c48b52e9c6f66a059">wiced_bt_create_heap</ref></para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>void </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="114" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1gaa0382948eb39d8de2496e8cd11ee13ce" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga8eb99f9920449033af7323ed0eb8f69c">wiced_bt_pool_t</ref> *</type>
        <definition>wiced_bt_pool_t* wiced_bt_create_pool</definition>
        <argsstring>(const char *name, uint32_t buffer_size, uint32_t buffer_cnt, wiced_bt_lock_t *p_lock)</argsstring>
        <name>wiced_bt_create_pool</name>
        <param>
          <type>const char *</type>
          <declname>name</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>buffer_size</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>buffer_cnt</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__lock__t">wiced_bt_lock_t</ref> *</type>
          <declname>p_lock</declname>
        </param>
        <briefdescription>
<para>Creates a buffer pool for application usage. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">name</parametername>
</parameternamelist>
<parameterdescription>
<para>: Friendly name of the heap </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">buffer_size</parametername>
</parameternamelist>
<parameterdescription>
<para>Size of the buffers in the pool </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">buffer_cnt</parametername>
</parameternamelist>
<parameterdescription>
<para>: Number of buffers in the pool </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_lock</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointers to lock functions to use during heap manipulation. If NULL, then it is assumed that the application handles disabling of preemption.</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>pointer to the created pool on success, or NULL on failure </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="127" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga5180d91f266fbb45fb60ec66485b5c2e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_delete_pool</definition>
        <argsstring>(wiced_bt_pool_t *p_pool)</argsstring>
        <name>wiced_bt_delete_pool</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga8eb99f9920449033af7323ed0eb8f69c">wiced_bt_pool_t</ref> *</type>
          <declname>p_pool</declname>
        </param>
        <briefdescription>
<para>Deletes a buffer pool created using <ref kindref="member" refid="group__wiced__mem_1gaa0382948eb39d8de2496e8cd11ee13ce">wiced_bt_create_pool</ref>. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_pool</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer of type <ref kindref="member" refid="group__wiced__mem_1ga8eb99f9920449033af7323ed0eb8f69c">wiced_bt_pool_t</ref> returned through a call to <ref kindref="member" refid="group__wiced__mem_1gaa0382948eb39d8de2496e8cd11ee13ce">wiced_bt_create_pool</ref></para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>void </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="136" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga910b98d98329582dd523d2e75a0a8377" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
        <definition>wiced_bt_buffer_t* wiced_bt_get_buffer_from_pool_no_trace</definition>
        <argsstring>(wiced_bt_pool_t *p_pool)</argsstring>
        <name>wiced_bt_get_buffer_from_pool_no_trace</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga8eb99f9920449033af7323ed0eb8f69c">wiced_bt_pool_t</ref> *</type>
          <declname>p_pool</declname>
        </param>
        <briefdescription>
<para>Get buffer from requested pool. </para>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="146" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga341ba13b1ef5b4667ea039bdcc7497ae" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
        <definition>wiced_bt_buffer_t* wiced_bt_get_buffer_from_heap_no_trace</definition>
        <argsstring>(wiced_bt_heap_t *p_heap, uint32_t size)</argsstring>
        <name>wiced_bt_get_buffer_from_heap_no_trace</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga29951f8f099d15eb96c47cfbdf656c3c">wiced_bt_heap_t</ref> *</type>
          <declname>p_heap</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>size</declname>
        </param>
        <briefdescription>
<para>Get buffer from requested heap. </para>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="164" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1gac2d26815b0ed4aa9f7d72650d7c5b28f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t wiced_bt_get_pool_free_count</definition>
        <argsstring>(wiced_bt_pool_t *p_pool)</argsstring>
        <name>wiced_bt_get_pool_free_count</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga8eb99f9920449033af7323ed0eb8f69c">wiced_bt_pool_t</ref> *</type>
          <declname>p_pool</declname>
        </param>
        <briefdescription>
<para>To get the number of buffers available in the pool. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_pool</parametername>
</parameternamelist>
<parameterdescription>
<para>: pool pointer</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the number of buffers available in the pool </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="194" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga1f954d898c5466a865a47ab097f385e7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t wiced_bt_get_largest_heap_buffer</definition>
        <argsstring>(wiced_bt_heap_t *p_heap)</argsstring>
        <name>wiced_bt_get_largest_heap_buffer</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga29951f8f099d15eb96c47cfbdf656c3c">wiced_bt_heap_t</ref> *</type>
          <declname>p_heap</declname>
        </param>
        <briefdescription>
<para>To get the size of the largest buffer available in the heap. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_heap</parametername>
</parameternamelist>
<parameterdescription>
<para>: heap pointer</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the size of the largest buffer available in the heap </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="203" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga27b156985fcf0d1f9334abbc5e13b630" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_free_buffer_no_trace</definition>
        <argsstring>(wiced_bt_buffer_t *p_buf)</argsstring>
        <name>wiced_bt_free_buffer_no_trace</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
          <declname>p_buf</declname>
        </param>
        <briefdescription>
<para>Free Buffer. </para>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="212" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga5d688277844f22111723e3339e725d8a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t wiced_bt_get_buffer_size</definition>
        <argsstring>(wiced_bt_buffer_t *p_buf)</argsstring>
        <name>wiced_bt_get_buffer_size</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
          <declname>p_buf</declname>
        </param>
        <briefdescription>
<para>Gets the buffer size. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_buf</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to the start of the buffer</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the buffer size </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="231" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga62e721c9f6a3f49dd10e5633a6a280ad" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_init_q</definition>
        <argsstring>(wiced_bt_buffer_q_t *p_q, wiced_bt_lock_t *p_lock)</argsstring>
        <name>wiced_bt_init_q</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</ref> *</type>
          <declname>p_q</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__lock__t">wiced_bt_lock_t</ref> *</type>
          <declname>p_lock</declname>
        </param>
        <briefdescription>
<para>Called by an application to initialize a WICED buffer queue. </para>
        </briefdescription>
        <detaileddescription>
<para>Pointers to lock and unlock functions may be NULL if application has handled preemption outside of the queue management code.</para>
<para><simplesect kind="return"><para>void </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="240" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga3142e3e24bbbf661867d9abd49bf94cd" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_enqueue</definition>
        <argsstring>(wiced_bt_buffer_q_t *p_q, wiced_bt_buffer_t *p_buf)</argsstring>
        <name>wiced_bt_enqueue</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</ref> *</type>
          <declname>p_q</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
          <declname>p_buf</declname>
        </param>
        <briefdescription>
<para>Enqueue a buffer at the tail of the queue. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_q</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to a queue. </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_buf</parametername>
</parameternamelist>
<parameterdescription>
<para>: address of the buffer to enqueue</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>void </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="250" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga3a76bfa31cc060df2c279049036c71b2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_bt_enqueue_head</definition>
        <argsstring>(wiced_bt_buffer_q_t *p_q, wiced_bt_buffer_t *p_buf)</argsstring>
        <name>wiced_bt_enqueue_head</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</ref> *</type>
          <declname>p_q</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
          <declname>p_buf</declname>
        </param>
        <briefdescription>
<para>Enqueue a buffer at the head of the queue. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_q</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to a queue. </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_buf</parametername>
</parameternamelist>
<parameterdescription>
<para>: address of the buffer to enqueue</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>void </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="260" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga1b0787e7f01a5eabf0fda49461d4a0fa" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
        <definition>wiced_bt_buffer_t* wiced_bt_dequeue</definition>
        <argsstring>(wiced_bt_buffer_q_t *p_q)</argsstring>
        <name>wiced_bt_dequeue</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</ref> *</type>
          <declname>p_q</declname>
        </param>
        <briefdescription>
<para>Dequeues a buffer from the head of a queue. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_q</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to a queue.</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>NULL if queue is empty, else buffer </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="269" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1gabf9a622ef54fe5731cec0a055923c96f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
        <definition>wiced_bt_buffer_t* wiced_bt_remove_from_queue</definition>
        <argsstring>(wiced_bt_buffer_q_t *p_q, wiced_bt_buffer_t *p_buf)</argsstring>
        <name>wiced_bt_remove_from_queue</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</ref> *</type>
          <declname>p_q</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
          <declname>p_buf</declname>
        </param>
        <briefdescription>
<para>Dequeue a buffer from the middle of the queue. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_q</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to a queue. </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">p_buf</parametername>
</parameternamelist>
<parameterdescription>
<para>: address of the buffer to dequeue</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>NULL if queue is empty, else buffer </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="279" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga3d0f730da71f5eefc2ffb8c7047f02f9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
        <definition>wiced_bt_buffer_t* wiced_bt_getfirst</definition>
        <argsstring>(wiced_bt_buffer_q_t *p_q)</argsstring>
        <name>wiced_bt_getfirst</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</ref> *</type>
          <declname>p_q</declname>
        </param>
        <briefdescription>
<para>Return a pointer to the first buffer in a queue. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_q</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to a queue.</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>NULL if queue is empty, else buffer address </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="288" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga0250fcacf935ca7fb2f0c802bc498316" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
        <definition>wiced_bt_buffer_t* wiced_bt_getlast</definition>
        <argsstring>(wiced_bt_buffer_q_t *p_q)</argsstring>
        <name>wiced_bt_getlast</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</ref> *</type>
          <declname>p_q</declname>
        </param>
        <briefdescription>
<para>Return a pointer to the last buffer in a queue. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_q</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to a queue.</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>NULL if queue is empty, else buffer address </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="297" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga88ac7077880864d79dbc134e460a814c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
        <definition>wiced_bt_buffer_t* wiced_bt_getnext</definition>
        <argsstring>(wiced_bt_buffer_t *p_buf)</argsstring>
        <name>wiced_bt_getnext</name>
        <param>
          <type><ref kindref="member" refid="group__wiced__mem_1ga46491871adba51d8026e9fa85acbbaba">wiced_bt_buffer_t</ref> *</type>
          <declname>p_buf</declname>
        </param>
        <briefdescription>
<para>Return a pointer to the next buffer in a queue. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_buf</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to the buffer to find the next one from.</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>NULL if no more buffers in the queue, else next buffer address </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="306" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga3a53857937701bb4c7c1128ed3de8f8a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t wiced_bt_queue_is_empty</definition>
        <argsstring>(wiced_bt_buffer_q_t *p_q)</argsstring>
        <name>wiced_bt_queue_is_empty</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__buffer__q__t">wiced_bt_buffer_q_t</ref> *</type>
          <declname>p_q</declname>
        </param>
        <briefdescription>
<para>Check the status of a queue. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_q</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to a queue.</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>TRUE if queue is empty, else FALSE </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="315" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga781d441cbf87a58a121c92fb9132d9b1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__gentypes_1ga2bc92bd117cfd3f6ec4ae452e6ced064">wiced_bool_t</ref></type>
        <definition>wiced_bool_t wiced_bt_get_heap_statistics</definition>
        <argsstring>(void *p_heap, wiced_bt_heap_statistics_t *p_stats)</argsstring>
        <name>wiced_bt_get_heap_statistics</name>
        <param>
          <type>void *</type>
          <declname>p_heap</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structwiced__bt__heap__statistics__t">wiced_bt_heap_statistics_t</ref> *</type>
          <declname>p_stats</declname>
        </param>
        <briefdescription>
<para>Get/Print the heap stats. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_heap</parametername>
</parameternamelist>
<parameterdescription>
<para>: heap pointer (output of <ref kindref="member" refid="group__wiced__mem_1gabd087700ddd0362c48b52e9c6f66a059">wiced_bt_create_heap</ref>) </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">p_stats</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to receive the heap statistics</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>TRUE in case of valid stats returned in p_stats </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="325" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__wiced__mem_1ga9a5e60280610d3027effc84ee35654b6" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void wiced_set_exception_callback</definition>
        <argsstring>(pf_wiced_exception pf_handler)</argsstring>
        <name>wiced_set_exception_callback</name>
        <param>
          <type><ref kindref="member" refid="group__gentypes_1gabc649ae1a0417bf22e71c4b72543a67f">pf_wiced_exception</ref></type>
          <declname>pf_handler</declname>
        </param>
        <briefdescription>
<para>Set the exception callback. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">pf_handler</parametername>
</parameternamelist>
<parameterdescription>
<para>: Exception callback function</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>void </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="334" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="define">
      <memberdef id="group__wiced__mem_1ga78170f22302a94b73e7852dc7dd735e5" kind="define" prot="public" static="no">
        <name>WICED_MEMORY_DEBUG_ENABLE</name>
        <initializer><ref kindref="member" refid="group__gentypes_1gaa93f0eb578d23995850d61f7d61c55c1">FALSE</ref></initializer>
        <briefdescription>
<para>Debug Memory Level. </para>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="21" column="10" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="21" />
      </memberdef>
      <memberdef id="group__wiced__mem_1ga9ddff2d22209edda9d0193a2c81dacfc" kind="define" prot="public" static="no">
        <name>WICED_DEFAULT_HEAP</name>
        <initializer>((<ref kindref="member" refid="group__wiced__mem_1ga29951f8f099d15eb96c47cfbdf656c3c">wiced_bt_heap_t</ref> *)NULL)</initializer>
        <briefdescription>
<para>If an application wants to get a buffer from the default heap, he can use this. </para>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="35" column="9" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="35" />
      </memberdef>
      <memberdef id="group__wiced__mem_1ga9a6e6f746b35c80eb116d7185393fb0f" kind="define" prot="public" static="no">
        <name>wiced_bt_get_buffer_from_pool</name>
        <param><defname>pool</defname></param>
        <initializer><ref kindref="member" refid="group__wiced__mem_1ga910b98d98329582dd523d2e75a0a8377">wiced_bt_get_buffer_from_pool_no_trace</ref>((pool))</initializer>
        <briefdescription>
<para>Allocates a buffer from the requested pool. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">pool</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to pool from which to get the buffer</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the pointer to the buffer or NULL on failure </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="154" column="9" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="154" />
      </memberdef>
      <memberdef id="group__wiced__mem_1ga52012ce59e91c900e60036de6db7c186" kind="define" prot="public" static="no">
        <name>wiced_bt_get_buffer_from_heap</name>
        <param><defname>heap</defname></param>
        <param><defname>size</defname></param>
        <initializer><ref kindref="member" refid="group__wiced__mem_1ga341ba13b1ef5b4667ea039bdcc7497ae">wiced_bt_get_buffer_from_heap_no_trace</ref>((heap), (size))</initializer>
        <briefdescription>
<para>Allocates a buffer from the requested heap. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">heap</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to heap from which to get the buffer </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>: size to be allocated</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the pointer to the buffer or NULL on failure </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="173" column="9" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="173" />
      </memberdef>
      <memberdef id="group__wiced__mem_1ga39d0dd9d7e6155ba49d6a76c079405b7" kind="define" prot="public" static="no">
        <name>wiced_bt_get_buffer</name>
        <param><defname>size</defname></param>
        <initializer><ref kindref="member" refid="group__wiced__mem_1ga52012ce59e91c900e60036de6db7c186">wiced_bt_get_buffer_from_heap</ref>(<ref kindref="member" refid="group__wiced__mem_1ga9ddff2d22209edda9d0193a2c81dacfc">WICED_DEFAULT_HEAP</ref>, (size))</initializer>
        <briefdescription>
<para>Allocates a buffer from the <bold> DEFAULT heap </bold>. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>: size to be allocated</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the pointer to the buffer or NULL on failure </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="184" column="9" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="184" />
      </memberdef>
      <memberdef id="group__wiced__mem_1ga42b92b2a1d461bfeb7af418673382058" kind="define" prot="public" static="no">
        <name>wiced_bt_free_buffer</name>
        <param><defname>free_buf</defname></param>
        <initializer><ref kindref="member" refid="group__wiced__mem_1ga27b156985fcf0d1f9334abbc5e13b630">wiced_bt_free_buffer_no_trace</ref>(free_buf)</initializer>
        <briefdescription>
<para>Frees a buffer back to the pool or heap it came from. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">free_buf</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to the start of the (pool/heap) buffer to be freed</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>None </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" bodystart="220" column="9" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_memory.h" line="220" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Helper APIs to create heaps and pools and allocate/free buffers from those pools or heaps. </para>
    </briefdescription>
    <detaileddescription>
<para>When a heap or a pool is created, this utility allocates required chunk of memory from the system and manages it for the creator. </para>
    </detaileddescription>
  </compounddef>
</doxygen>